import {
    CanActivate,
    ExecutionContext,
    ForbiddenException,
    Injectable,
    UnauthorizedException,
} from '@nestjs/common';
import { GqlExecutionContext } from '@nestjs/graphql';
import { Request } from 'express';
import { PrismaService } from '../prisma/prisma.service';

@Injectable()
export class AgentAuthGuard implements CanActivate {
    constructor(private prismaService: PrismaService) {}

    async canActivate(context: ExecutionContext): Promise<boolean> {
        const ctx = GqlExecutionContext.create(context);

        const req: Request = ctx.getContext().req;

        console.log(ctx.getArgs());

        return true;

        const token = req.headers.authorization;

        if (!token) throw new UnauthorizedException();

        req.agent = await this.prismaService.agent.findFirst({
            where: { id: token },
        });

        if (!req.agent) throw new ForbiddenException();

        return true;
    }
}
